# Outside client for tkgoodstuff
# Outside data from Weather Underground

proc OutsideDeclare {} {
    TKGDeclare Outside(interval) 900 -typelist [list Clients Outside]\
	-label "How often to check the conditions (seconds)"
    TKGDeclare Outside(url) http://www.wunderground.com/US/MI/Ann_Arbor.html \
	-typelist [list Clients Outside]\
	-label "URL for forecast" \
	-help "Outside.tcl understands only Weather Underground forecasts."
    TKGDeclare Outside(command) {TKGBrowse http://www.wunderground.com/US/MI/Ann_Arbor.html}\
	-typelist [list Clients Outside]\
	-label "Tcl command to run on a click"
    TKGDeclare Outside(exec) {} -typelist [list Clients Outside]\
	-label "Unix command to run on a click"
    TKGDeclare Outside(lines) 1 -vartype boolean -typelist [list Clients Outside]\
	-label "Split line between temperature and humidity"    
}

proc OutsideCreateWindow {} {
    global Outside Outside-params TKG
    if [TKGReGrid Outside] return
    TKGMakeButton Outside \
	-command $Outside(command)\
	-exec $Outside(exec)\
	-text [OutsideUpdateText Outside... ??? ???]\
	-balloon "No data yet"
    
    package require http

    TKGPeriodic outside $Outside(interval) 3 OutsideUpdate
}

proc OutsideUpdateText {time temperature humidity} {
    global Outside
    if $Outside(lines) {
	set text "$time\n$temperature\n$humidity"
    } else {
	append text "$time\n$temperature $humidity"
    }
    return $text
}

proc OutsideUpdate {} {
    global Outside
    http_get $Outside(url) -command OutsidePost
}

proc OutsidePost {token} {
    upvar \#0 $token state
    if [regexp {(Conditions\ at[^
]*).*Temperature[^-+0-9]*([-+0-9]*).*Humidity[^0-9]*([0-9]*\%)} \
	    $state(body) dummy timeline temperature humidity] {
	regsub -all {<b>} $timeline {} timeline
	regsub -all {<\/b>} $timeline {} timeline
	regexp {at\ ([^\ ]*)} $timeline time time
	TKGButton Outside \
	    -text [OutsideUpdateText "At $time:" "$temperature F" $humidity] \
	    -balloon "$timeline\nfrom www.wunderground.com"
    } else {
	TKGButton Outside -text [OutsideUpdateText error error] -balloon "Something is wrong"
    }
}
